﻿package
{
	import de.popforge.audio.output.Audio;
	import de.popforge.audio.output.SoundFactory;
	
	import flash.display.Sprite;
	import flash.media.Sound;
	import flash.utils.ByteArray
	import flash.utils.Endian
	

	public class SirenASound_REF extends Sprite
	{
		
		//バイナリーとしてwavを読み込み、Class化
		[Embed(source="wav/siren_short.wav", mimeType="application/octet-stream")]
		public static const Song:Class;
		
		//wavファイルヘッダー部分のoffset
		public static const WAV_HEADER_END:uint = 44
		
		public function SirenASound_REF(){
			init();
		}
		
		private function init(): void {
			//バイトコードを取得
			var bytes:ByteArray = getByteArray()		
			var array:Array = byteArray2Array(bytes)
			
			//effectの有無　1オクターブ高くなる
			//array = effect(array)
			//var bytes2:ByteArray = array2ByteArray(array)
			
			//fromByteArrayにバイトコードを渡す
			SoundFactory.fromByteArray(bytes,Audio.STEREO, Audio.BIT16, Audio.RATE44100, onSoundGenerated );
		}
		
		private function onSoundGenerated( sound: Sound ): void {
			//再生
			sound.play();
		}
		
		private function getByteArray():ByteArray {
			var bytes:ByteArray = new ByteArray()
			bytes.endian = Endian.LITTLE_ENDIAN
			var wavData:ByteArray = new Song() as ByteArray
			bytes.writeBytes(wavData, WAV_HEADER_END)
			bytes.position = 0		
			return bytes;
		}
		
		private function byteArray2Array(bytes:ByteArray):Array {
			var array:Array = new Array()
			while(bytes.position < bytes.length-1){array.push(bytes.readShort())}			
			return array;
		}
		private function array2ByteArray(array:Array):ByteArray {
			var bytes:ByteArray = new ByteArray()
			bytes.endian = Endian.LITTLE_ENDIAN
			for each(var index:int in array){bytes.writeShort(index)}			
			bytes.position = 0
			return bytes;
		}
		
		private function effect(sample:Array):Array {
			var array:Array = new Array()
			for (var i:int = 0; i < sample.length;i+=2){
				array.push(sample[i])
			}
			
			return array
		}
	}
}